﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Data;
using System.IO;
using Devart.Data.Oracle;

namespace WindowsFormsApp1
{
    public class OracleHelper
    {
        public static string strConn = "";
        public static string SdestrConn = "";
        public static string strConnOther = "";

        static private OracleConnection oraConn = null;
        static private OracleConnection SdeoraConn = null;
        static private OracleTransaction oraTransaction;
        static public OracleConnection oraConnOther = null;
        public OracleHelper()
        {

        }


        /// <summary>测试oracle连接是否能成功打开
        /// </summary>
        /// <param name="servername">服务名</param>
        /// <param name="username">用户名</param>
        /// <param name="password">密码</param>
        /// <returns></returns>
        public static bool testopenoraclecon()
        {
            try
            {
                OracleConnection oracon = new OracleConnection(orclstr);
                oracon.Open();
                oracon.Close();
            }
            catch (OracleException ex)
            {
                return false;
            }
            return true;
        }
        private static string orclstr = "User Id=X;Password=X;Server=1.2.3.4;Direct=True;Sid=ORCL;port=1521;";
        public static OracleConnection sqlOpen()
        {
            if (strConn == "")
            {
                strConn = orclstr;
            }
            if (oraConn == null)
            {
                oraConn = new OracleConnection(strConn);
            }
            try
            {
                if (oraConn.State == ConnectionState.Closed)
                {
                    oraConn.Open();
                }
                return oraConn;
            }
            catch (Exception ex)
            {
                oraConn.Close();
                //throw ex;
                return null;
            }
        }

     

        /// <summary>
        ///通过sql语句获得数据表
        /// </summary>
        /// <param name="strSql"></param> 
        /// <returns></returns> 

        public static DataTable getDataTableBySql(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            DataSet myDs;
            OracleDataAdapter myDataAdapter = null;
            try
            {
                myDataAdapter = new OracleDataAdapter(strSql, oraConn);
                myDs = new DataSet();
                myDataAdapter.Fill(myDs);
                myDataAdapter.Dispose();
                //oraConn.Close();
                return myDs.Tables[0];
                //myDs.Tables[0].Columns.Add("aaa", typeof(System.Byte));
            }
            catch (Exception ex)
            {
                myDataAdapter.Dispose();
                return null;
            }
        }

        public static OracleDataReader CurrentBaseReader(string strSql)
        {
            if (oraConnOther == null)
            {
                oraConnOther = sqlOpen();
            }
            if (oraConnOther.State == ConnectionState.Closed)
            {
                oraConnOther.Open();
            }
            OracleDataReader reader = null;
            try
            {
                OracleCommand cmd = oraConnOther.CreateCommand();
                cmd.CommandText = strSql;
                //oraConnOther.Open();
                reader = cmd.ExecuteReader();

                //reader.Close();
                //oraConnOther.Close();
                return reader;
            }
            catch
            {
                //reader.Close();
                return null;
            }
        }

  
        public static string GetType(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleDataReader reader = null;
            try
            {
                string type = "";
                OracleCommand cmd = oraConn.CreateCommand();
                cmd.CommandText = strSql;
                reader = cmd.ExecuteReader();
                while (reader.Read())
                {
                    if (reader.HasRows == true)
                    {
                        type = reader[0].ToString();
                    }
                }

                reader.Close();
                reader.Dispose();
                //oraConn.Close();
                return type;
            }
            catch
            {
                reader.Close();
                return "";
            }
        }

        public static string GetTypeEx(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn.Open();
            }
            OracleDataReader reader = null;
            try
            {
                string type = "";
                OracleCommand cmd = oraConn.CreateCommand();
                cmd.CommandText = strSql;
                reader = cmd.ExecuteReader();
                while (reader.Read())
                {
                    if (reader.HasRows == true)
                    {
                        type = reader[0].ToString();
                    }
                }

                reader.Close();
                reader.Dispose();
                //oraConn.Close();
                return type;
            }
            catch
            {
                reader.Close();
                return "";
            }
        }

        public static void CloseRedear(OracleDataReader reader)
        {
            reader.Close();
            oraConnOther.Close();
        }

        /// <summary>
        /// 判断数据库内是否存在
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public static bool Exists(string strSql, OracleParameter[] parameters)
        {
            int iReturn = ExecuteByScalar(strSql, parameters);
            return iReturn > 0 ? true : false;
        }

        /// <summary>
        /// 执行多条sql语句
        /// </summary>
        /// <param name="strSqlList"></param>
        /// <returns></returns>
        public static int ExecuteBySqlByCount(List<string> strSqlList)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleTransaction myTrans = oraConn.BeginTransaction();
            OracleCommand mySqlCommand = oraConn.CreateCommand();
            mySqlCommand.Transaction = myTrans;
            int Rows = 0;
            try
            {
                int i = 0;
                foreach (string strSql in strSqlList)
                {
                    mySqlCommand.CommandText = strSql;
                    Rows += mySqlCommand.ExecuteNonQuery();
                    i++;
                    if (i >= 1000)
                    {
                        myTrans.Commit();
                        myTrans = oraConn.BeginTransaction();
                        mySqlCommand.Transaction = myTrans;
                        i = 0;
                    }
                }
                myTrans.Commit();
                mySqlCommand.Dispose();
                //oraConn.Close();
                //oraConn = null;
                return Rows;
            }
            catch (Exception)
            {
                myTrans.Rollback();
                mySqlCommand.Dispose();
                return -1;
            }
        }
        public static OracleCommand mySqlCommandBolb = null;
        public static OracleTransaction myTransBolb = null;
        public static void openTransactionBolb()
        {
            if (myTransBolb == null)
            {
                myTransBolb = oraConn.BeginTransaction();
                mySqlCommandBolb = oraConn.CreateCommand();
                mySqlCommandBolb.Transaction = myTransBolb;
            }
        }



        public static int ExecuteBySqlBolb(string strSql, OracleParameter[] parameters)
        {
            //执行插入操作
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            int Rows = 0;
            OracleTransaction myTrans = oraConn.BeginTransaction();
            OracleCommand mySqlCommand = oraConn.CreateCommand();
            mySqlCommand.Transaction = myTrans;
            try
            {

                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                mySqlCommand.Parameters.AddRange(parameters);
                Rows = (int)mySqlCommand.ExecuteNonQuery();
                if (Rows > 0)
                    myTrans.Commit();
                mySqlCommand.Parameters.Clear();
                mySqlCommand.Dispose();
                //oraConn.Close();
                //oraConn = null;
                return Rows;
            }
            catch (Exception)
            {
                myTrans.Rollback();
                mySqlCommand.Parameters.Clear();
                mySqlCommand.Dispose();
                mySqlCommand.Connection.Close();
                return -1;
            }
            return 0;
        }
        public static void closeTransactionBolb()
        {
            try
            {
                if (mySqlCommandBolb != null)
                {
                    mySqlCommandBolb.Dispose();
                }
                oraConn.Close();
                //oraConn = null;
            }
            catch (Exception) { return; }
        }

        public static void CommitBlob()
        {
            if (myTransBolb != null)
            {
                myTransBolb.Commit();
            }
        }

        /// <summary>
        /// 执行多条sql语句
        /// </summary>
        /// <param name="strSqlList"></param>
        /// <returns></returns>
        public static int ExecuteBySql(List<string> strSqlList)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleTransaction myTrans = oraConn.BeginTransaction();
            OracleCommand mySqlCommand = oraConn.CreateCommand();
            mySqlCommand.Transaction = myTrans;
            int Rows = 0;
            try
            {
                foreach (string strSql in strSqlList)
                {
                    mySqlCommand.CommandText = strSql;
                    Rows += mySqlCommand.ExecuteNonQuery();
                }
                myTrans.Commit();
                mySqlCommand.Dispose();
                //oraConn.Close();
                //oraConn = null;
                return Rows;
            }
            catch (Exception ex)
            {
                //Local.LocalLogClass.CreateLogEx("ExecuteBySql失败：" + ex.Message);
                myTrans.Rollback();
                mySqlCommand.Dispose();
                return -1;
            }
        }

        /// <summary>
        /// 执行单条sql语句
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static int ExecuteSql(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            int Rows = 0;
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                Rows = (int)mySqlCommand.ExecuteNonQuery();
                mySqlCommand.Dispose();
                return Rows;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return -1;
            }
            finally
            {
                mySqlCommand.Dispose();
            }
        }




        /// <summary>
        /// 执行单条sql语句
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public static int ExecuteSql(string strSql, OracleParameter[] parameters)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            int Rows = 0;

            using (OracleTransaction Trans = oraConn.BeginTransaction())
            {
                try
                {
                    mySqlCommand.Transaction = Trans;
                    mySqlCommand.Connection = oraConn;
                    mySqlCommand.CommandText = strSql;
                    mySqlCommand.Parameters.AddRange(parameters);
                    Rows = (int)mySqlCommand.ExecuteNonQuery();

                    Trans.Commit();
                    return Rows;
                }
                catch (Exception)
                {
                    Trans.Rollback();
                    return -1;
                }
                finally
                {
                    mySqlCommand.Dispose();
                }
            }
        }

        /// <summary>
        /// 执行单行SQL语句，并把首行首列作为特定的数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static int ExecuteByScalar(string strSql, OracleParameter[] parameters)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = oraConn.CreateCommand();
            int Rows = 0;
            try
            {
                mySqlCommand.CommandText = strSql;
                if (parameters != null)
                {
                    mySqlCommand.Parameters.AddRange(parameters);
                }
                Rows = Convert.ToInt32(mySqlCommand.ExecuteScalar());
                return Rows;
            }
            catch (Exception)
            {
                return -1;
            }
            finally
            {

            }
        }

        /// <summary>
        /// 执行单行SQL语句，并把首行首列作为Object数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static object ExecuteByScalarObject(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            object Rows = null;
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                Rows = mySqlCommand.ExecuteScalar();
                mySqlCommand.Dispose();
                if (Rows == null)
                {
                    return 1;
                }
                return Rows;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return null;
            }
            finally
            {
                mySqlCommand.Dispose();
            }
        }

        /// <summary>
        /// 执行单行SQL语句，并把首行首列作为Object数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static int ExecuteByScalarObject1(string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            object Rows = null;
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                Rows = mySqlCommand.ExecuteScalar();
                mySqlCommand.Dispose();
                if (Rows == null)
                {
                    return -1;
                }
                return 1;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return -1;
            }
            finally
            {
                mySqlCommand.Dispose();
            }
        }

        /// <summary>
        /// 执行单行SQL语句，并把查询内容作为Dataset数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static DataSet Query(string strSql)
        {
            DataSet pDataset = new DataSet();
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }

            OracleCommand mySqlCommand = new OracleCommand();
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                OracleDataAdapter pAdapter = new OracleDataAdapter(mySqlCommand);
                pAdapter.Fill(pDataset);

                mySqlCommand.Dispose();
                return pDataset;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return pDataset;
            }
            finally
            {
            }
        }


        /// <summary>
        /// 执行单行SQL语句，并把查询内容作为Dataset数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static DataSet Query(string strSql, OracleParameter[] parameters)
        {

            DataSet pDataset = new DataSet();
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }

            OracleCommand mySqlCommand = new OracleCommand();
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                mySqlCommand.Parameters.AddRange(parameters);
                OracleDataAdapter pAdapter = new OracleDataAdapter(mySqlCommand);
                pAdapter.Fill(pDataset);
                return pDataset;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return pDataset;
            }
            finally
            {
                mySqlCommand.Dispose();
            }
        }




        /// <summary>
        /// 执行存储过程
        /// </summary>
        /// <param name="sName"></param>
        /// <param name="pParams"></param>
        /// <returns></returns>
        public static void ExcutePro(string sName, OracleParameter[] pParams)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand pCommand = new OracleCommand();
            try
            {
                pCommand.Connection = oraConn;
                pCommand.CommandType = CommandType.StoredProcedure;
                pCommand.CommandText = sName;
                if (pParams != null)
                {
                    pCommand.Parameters.AddRange(pParams);
                }
                pCommand.CommandTimeout = 200;

                pCommand.ExecuteNonQuery();
            }
            catch (Exception)
            {
                pCommand.Dispose();
            }
            finally
            {
                oraConn.Close();
            }

        }


        /// <summary>
        /// 执行存储过程
        /// </summary>
        /// <param name="sName"></param>
        /// <param name="pParams"></param>
        /// <param name="sTableName"></param>
        /// <returns></returns>
        public static DataSet ExcutePro(string sName, OracleParameter[] pParams, string sTableName)
        {
            DataSet pDataset = new DataSet();
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand pCommand = new OracleCommand();
            try
            {
                pCommand.Connection = oraConn;
                pCommand.CommandType = CommandType.StoredProcedure;
                pCommand.CommandText = sName;
                if (pParams != null)
                {
                    pCommand.Parameters.AddRange(pParams);
                }
                pCommand.CommandTimeout = 200;
                OracleDataAdapter pAdapter = new OracleDataAdapter(pCommand);
                if (sTableName == "")
                {
                    pAdapter.Fill(pDataset);
                }
                else
                {
                    pAdapter.Fill(pDataset, sTableName);
                }
                pCommand.Dispose();
                return pDataset;
            }
            catch (Exception)
            {
                pCommand.Dispose();
                return pDataset;
            }
            finally
            {
            }

        }

        /// <summary>
        /// 执行单行SQL语句，并把首行首列作为Object数据类型返回
        /// </summary>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static DataSet RunProcedure(string sName, OracleParameter[] pParams, string sTableName)
        {
            return ExcutePro(sName, pParams, sTableName);
        }



        /// <summary>
        /// 将文件或者字符保存到数据库Blob字段
        /// </summary>
        /// <param name="transferByte"></param>
        /// <param name="strSql"></param>
        /// <returns></returns>
        public static int ExecuteWriteBlobSql(Byte[] transferByte, string strSql)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            int Rows = 0;
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                OracleParameter param = new OracleParameter
                    ("ParName", OracleDbType.Blob, transferByte.Length, ParameterDirection.Input, false, 0, 0, null, DataRowVersion.Current, transferByte);
                mySqlCommand.Parameters.Add(param);
                Rows = (int)mySqlCommand.ExecuteNonQuery();
                mySqlCommand.Dispose();
                //oraConn.Close();
                //oraConn = null;
                return Rows;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return 0;
            }
        }
        /// <summary>将文件或者字符保存到数据库Blob字段
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="?"></param>
        /// <param name="parameters"></param>
        /// <returns></returns>
        public static int ExecuteWriteBlobSql(string strSql, OracleParameter[] parameters)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            int Rows = 0;
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                //OracleParameter param = new OracleParameter
                //    ("ParName", OracleType.Blob, transferByte.Length, ParameterDirection.Input, false, 0, 0, null, DataRowVersion.Current, transferByte);
                mySqlCommand.Parameters.AddRange(parameters);
                Rows = (int)mySqlCommand.ExecuteNonQuery();
                mySqlCommand.Dispose();
                //oraConn.Close();
                //oraConn = null;
                return Rows;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
                return -1;
            }
        }
        /// <summary>
        /// 根据sql语句获取存储在oracle中Blog字段的文件，并下载为制定文件名路径 
        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="strField"></param>
        /// <param name="strFilePath"></param>
        public static bool DownFileFromOracleBySql(string strSql, string strField, string strFilePath)
        {
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                OracleDataReader myOraReader = mySqlCommand.ExecuteReader();
                if (myOraReader.Read())
                {
                    byte[] File = (byte[])myOraReader[strField];
                    System.IO.FileStream fileS = new System.IO.FileStream(strFilePath, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.Write, System.IO.FileShare.Write);
                    System.IO.BinaryWriter fileWriter = new System.IO.BinaryWriter(fileS);
                    fileWriter.Write(File);
                    fileWriter.Flush();
                    fileWriter.Close();
                }
                mySqlCommand.Dispose();
                return true;
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
            }
            return false;
        }
        /// <summary>
        /// 下载Oracle的Blob字段转换为字符

        /// </summary>
        /// <param name="strSql"></param>
        /// <param name="strField"></param>
        /// <returns></returns>
        public static string DownStringInfoBlobSql(string strSql, string strField)
        {
            string fileStr = "";
            if (oraConn == null)
            {
                oraConn = sqlOpen();
            }
            if (oraConn.State == ConnectionState.Closed)
            {
                oraConn = sqlOpen();
            }
            OracleCommand mySqlCommand = new OracleCommand();
            try
            {
                mySqlCommand.Connection = oraConn;
                mySqlCommand.CommandText = strSql;
                OracleDataReader myOraReader = mySqlCommand.ExecuteReader();
                if (myOraReader.Read())
                {
                    byte[] File = (byte[])myOraReader[strField];
                    fileStr = System.Text.Encoding.ASCII.GetString(File);
                }
                mySqlCommand.Dispose();
            }
            catch (Exception)
            {
                mySqlCommand.Dispose();
            }
            return fileStr;
        }

    }


}
